<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button v-waves class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
      <el-button v-waves :loading="downloading" class="filter-item" type="primary" icon="el-icon-download" @click="handleDownload">
        {{ $t('table.export') }}
      </el-button>
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column min-width="300px" align="center" :label="$t('form.token_symbol')">
        <template slot-scope="scope">
          <span>{{ scope.row.token_symbol }}</span>
        </template>
      </el-table-column>
      <el-table-column min-width="300px" align="center" :label="$t('row.token')">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>

      <el-table-column width="320px" align="center" :label="$t('row.amount')">
        <template slot-scope="scope">
          <span>{{ scope.row.must_amount }}</span>
        </template>
      </el-table-column>

      <el-table-column width="200px" :label="$t('row.price')">
        <template slot-scope="scope">
          <span>{{ scope.row.token_nominal_value }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('row.operation')" width="200">
        <template slot-scope="scope">
          <router-link :to="'/administrator/articles/edit/'+scope.row.id">
            <el-button type="primary" size="small" icon="el-icon-edit">
              <!--{{ $t('row.transmit') }}-->
            </el-button>
          </router-link>
          <router-link :to="'/administrator/articles/edit/'+scope.row.id">
            <el-button type="danger" size="small" icon="el-icon-remove">
              <!--{{ $t('row.remove') }}-->
            </el-button>
          </router-link>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Token from '@/api/token';
const tokenResource = new Token('tokens');

export default {
  name: 'TokenList',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      total: 0,
      listLoading: true,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await tokenResource.list(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
  },
};
</script>

<style scoped>
.edit-input {
  padding-right: 100px;
}
.cancel-btn {
  position: absolute;
  right: 15px;
  top: 10px;
}
</style>
